"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.QueryFactory = void 0;
class QueryFactory {
    constructor(cubeToQueryClass) {
        this.cubeToQueryClass = cubeToQueryClass;
    }
    createQuery(cube, compilers, queryOptions) {
        if (!(cube in this.cubeToQueryClass)) {
            throw new Error(`Undefined cube '${cube}'`);
        }
        const QueryClass = this.cubeToQueryClass[cube];
        if (!QueryClass) {
            throw new Error(`Undefined dbType or dialectClass for '${cube}'`);
        }
        return new QueryClass(compilers, queryOptions);
    }
}
exports.QueryFactory = QueryFactory;
//# sourceMappingURL=QueryFactory.js.map