import { StatementContext } from './GenericSqlParser';
interface SyntaxError {
    msg: string;
    column: number;
    err: any;
    line: number;
    recognizer: any;
    offendingSymbol: any;
}
export declare class SqlParser {
    protected readonly sql: string;
    protected readonly ast: StatementContext;
    protected errors: SyntaxError[];
    constructor(sql: string);
    protected static sqlUpperCase(sql: any): string;
    protected parse(): StatementContext;
    canParse(): boolean;
    throwErrorsIfAny(): void;
    isSimpleAsteriskQuery(): boolean;
    extractWhereConditions(tableAlias: any): string;
    extractTableFrom(): string | null;
}
export {};
//# sourceMappingURL=SqlParser.d.ts.map